UsePNGImageDecoder()

; ############################################# Variablen #####################################

#Width = 500
#Height = 200

Global Exit.l
Global is_Doing.l

Global *Memory1 = AllocateMemory(#Width*#Height*4)
Global *Memory2 = AllocateMemory(#Width*#Height*4)

Structure Source_2_Output
  X.f
  Y.f
  R.f
  G.f
  B.f
EndStructure
Global Dim Source_2_Output.Source_2_Output(#Width,#Height)

Structure Window_Main
  ID.l
  Image_ID.l
  Image.l
EndStructure
Global Window_Main.Window_Main

Structure RGB
  R.b
  G.b
  B.b
EndStructure

; ############################################# Proceduren #####################################

Procedure Open_Window_Main()
  Window_Main\ID = OpenWindow(#PB_Any, 100, 100, #Width + 20, #Height + 20, "Guckloch",  #PB_Window_SystemMenu | #PB_Window_TitleBar )
  If Window_Main\ID
    If CreateGadgetList(WindowID(Window_Main\ID))
      Window_Main\Image_ID = CreateImage(#PB_Any, #Width, #Height)
      Window_Main\Image    = ImageGadget(#PB_Any, 10, 10, #Width, #Height, ImageID(Window_Main\Image_ID))
      
    EndIf
    
    SetWindowLong_(WindowID(Window_Main\ID),#GWL_EXSTYLE,$00080000)
    SetLayeredWindowAttributes_(WindowID(Window_Main\ID),0,255,2)
  EndIf
EndProcedure

Procedure CopyImageToMem(Img.l, mem.l)
  Protected bmi.BITMAPINFO 
  Protected w.l, h.l, hBmp.l, hDC.l 
  w = ImageWidth(Img) 
  h = ImageHeight(Img) 
  hBmp = ImageID(Img) 
  
  bmi\bmiHeader\biSize        = SizeOf(BITMAPINFOHEADER) 
  bmi\bmiHeader\biWidth       =  w 
  bmi\bmiHeader\biHeight      = -h 
  bmi\bmiHeader\biPlanes      =  1 
  bmi\bmiHeader\biBitCount    = 32
  bmi\bmiHeader\biCompression = #BI_RGB 
  
  hDC  = StartDrawing( ImageOutput(Img) ) 
  If GetDIBits_(hDC, hBmp, 0, h, mem, bmi, #DIB_RGB_COLORS) 
    StopDrawing() 
    ProcedureReturn #True 
  Else 
    StopDrawing() 
    ProcedureReturn #False 
  EndIf 
EndProcedure 

Procedure CopyMemToImage(mem.l, Img.l)
  Protected bmi.BITMAPINFO 
  Protected w.l, h.l, hBmp.l, hDC.l 
  w    = ImageWidth(Img) 
  h    = ImageHeight(Img) 
  hBmp = ImageID(Img) 
  
  bmi\bmiHeader\biSize        = SizeOf(BITMAPINFOHEADER) 
  bmi\bmiHeader\biWidth       =  w 
  bmi\bmiHeader\biHeight      = -h 
  bmi\bmiHeader\biPlanes      =  1 
  bmi\bmiHeader\biBitCount    = 32 
  bmi\bmiHeader\biCompression = #BI_RGB 
  
  hDC  = StartDrawing( ImageOutput(Img) ) 
  If SetDIBits_(hDC, hBmp, 0, h, mem, bmi, #DIB_RGB_COLORS) 
    StopDrawing() 
    ProcedureReturn #True 
  Else 
    StopDrawing() 
    ProcedureReturn #False 
  EndIf 
EndProcedure

Procedure Screenshot(X, Y, Width, Height)
   hDC    = StartDrawing(ImageOutput(Window_Main\Image_ID))
   DeskDC = GetDC_(GetDesktopWindow_())
   BitBlt_(hDC, 0, 0, Width, Height, DeskDC, X, Y, #SRCCOPY)
   StopDrawing()
   ReleaseDC_(GetDesktopWindow_(), DeskDC)
EndProcedure

Procedure Make_Source_2_Output_Random()
  For ix = 0 To #Width
    For iy = 0 To #Height
      Source_2_Output(ix,iy)\X = ix + Sin(ix*0.1)*2 + Random(100)*0.02
      Source_2_Output(ix,iy)\Y = iy + Cos(iy*0.1)*2 + Random(100)*0.02
      Source_2_Output(ix,iy)\R = 1 - Random(100)*0.002
      Source_2_Output(ix,iy)\G = 1 - Random(100)*0.002
      Source_2_Output(ix,iy)\B = 1 - Random(100)*0.002
      If Source_2_Output(ix,iy)\X < 0 : Source_2_Output(ix,iy)\X = 0 : EndIf
      If Source_2_Output(ix,iy)\X > #Width : Source_2_Output(ix,iy)\X = #Width : EndIf
      If Source_2_Output(ix,iy)\Y < 0 : Source_2_Output(ix,iy)\Y = 0 : EndIf
      If Source_2_Output(ix,iy)\Y > #Height : Source_2_Output(ix,iy)\Y = #Height : EndIf
    Next
  Next
EndProcedure

Procedure Make_Source_2_Output_Image(File_1.s, File_2.s)
  Image_ID_1 = LoadImage(#PB_Any, File_1)
  Image_ID_2 = LoadImage(#PB_Any, File_2)
  CopyImageToMem(Image_ID_1, *Memory1)
  CopyImageToMem(Image_ID_2, *Memory2)
  For ix = 0 To #Width
    For iy = 0 To #Height
      *RGB1.RGB = *Memory1 + (iX + iY*ImageWidth(Image_ID_1)) * 4
      *RGB2.RGB = *Memory2 + (iX + iY*ImageWidth(Image_ID_2)) * 4
      X = (*RGB1\R & 255 - 128)*0.05
      Y = (*RGB1\G & 255 - 128)*0.05
      R = *RGB2\R & 255
      G = *RGB2\G & 255
      B = *RGB2\B & 255
      Source_2_Output(ix,iy)\X = ix + X
      Source_2_Output(ix,iy)\Y = iy + Y
      Source_2_Output(ix,iy)\R = R / 256
      Source_2_Output(ix,iy)\G = G / 256
      Source_2_Output(ix,iy)\B = B / 256
      If Source_2_Output(ix,iy)\X < 0 : Source_2_Output(ix,iy)\X = 0 : EndIf
      If Source_2_Output(ix,iy)\X > #Width : Source_2_Output(ix,iy)\X = #Width : EndIf
      If Source_2_Output(ix,iy)\Y < 0 : Source_2_Output(ix,iy)\Y = 0 : EndIf
      If Source_2_Output(ix,iy)\Y > #Height : Source_2_Output(ix,iy)\Y = #Height : EndIf
    Next
  Next
  FreeImage(Image_ID_1)
  FreeImage(Image_ID_2)
EndProcedure

Procedure Do(X, Y)
  If is_Doing = 0
    is_Doing = 1
    Screenshot(X, Y, #Width, #Height)
    
    CopyImageToMem(Window_Main\Image_ID, *Memory1)
    
    For ix = 0 To #Width
      For iy = 0 To #Height
        *RGB2.RGB = *Memory2 + (ix + iy*#Width) * 4
        
        X = Source_2_Output(ix,iy)\X
        Y = Source_2_Output(ix,iy)\Y
        
        *RGB1.RGB = *Memory1 + (X + Y*#Width) * 4
        
        *RGB2\R = (*RGB1\R & 255) * Source_2_Output(ix,iy)\R
        *RGB2\G = (*RGB1\G & 255) * Source_2_Output(ix,iy)\G
        *RGB2\B = (*RGB1\B & 255) * Source_2_Output(ix,iy)\B
      Next
    Next
    
    CopyMemToImage(*Memory2, Window_Main\Image_ID)
    
    SetGadgetState(Window_Main\Image, ImageID(Window_Main\Image_ID))
    is_Doing = 0
  EndIf
EndProcedure

Procedure WinCallback(hWnd, uMsg, wParam, *lParam.rect) 
  If uMsg = #WM_MOVING
    Do(*lParam\left + 13, *lParam\top + 39)
  EndIf
  ProcedureReturn #PB_ProcessPureBasicEvents 
EndProcedure

; ############################################# Init #####################################

Open_Window_Main()

Make_Source_2_Output_Image("Bumpmap.png", "Color.png")

SetWindowCallback(@WinCallback())

; ############################################# Hauptschleife #####################################

Repeat
  Event = WaitWindowEvent(10)
  If Event = #PB_Event_Gadget
    Select EventGadget()
      
    EndSelect
  ElseIf Event = #PB_Event_CloseWindow
    Exit = 1
  EndIf
  Do(WindowX(Window_Main\ID) + 13, WindowY(Window_Main\ID) + 39)
Until Exit = 1
; IDE Options = PureBasic 4.20 Beta 4 (Windows - x86)
; CursorPosition = 192
; FirstLine = 153
; Folding = --
; EnableThread
; EnableXP
; DisableDebugger